diff -r af9017db699d src/generic/apt/aptcache.cc
--- a/src/generic/apt/aptcache.cc	Sun Jul 08 11:35:00 2007 -0700
+++ b/src/generic/apt/aptcache.cc	Sun Jul 08 12:44:44 2007 -0700
@@ -758,6 +758,15 @@ void aptitudeDepCache::cleanup_after_cha
   // selected_state if it's not already updated; (b) adds an item to the
   // undo group.
 {
+  // We get here with NULL backup_state in certain very early failures
+  // (e.g., when someone else is holding a lock).  In this case we
+  // don't know what the previous state was, so we can't possibly
+  // build a collection of undoers to return to it.
+  if(backup_state.PkgState == NULL ||
+     backup_state.DepState == NULL ||
+     backup_state.AptitudeState == NULL)
+    return;
+
   for(pkgCache::PkgIterator pkg=PkgBegin(); !pkg.end(); pkg++)
     {
       if(PkgState[pkg->ID].Mode!=backup_state.PkgState[pkg->ID].Mode ||
